	.file	"texture.c"
	.text
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	"1.6.37"
	.text
	.globl	init_png
	.type	init_png, @function
init_png:
.LFB22:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%rbx
	subq	$24, %rsp
	.cfi_offset 3, -24
1:	call	mcount
	movq	%rdi, %rbx
	movq	%rdi, -32(%rbp)
	movq	%rsi, -24(%rbp)
	movl	$0, %ecx
	movl	$0, %edx
	movl	$0, %esi
	movl	$.LC0, %edi
	call	png_create_read_struct
	movq	%rax, %rdi
	movq	%rax, (%rbx)
	testq	%rax, %rax
	je	.L6
	call	png_create_info_struct
	movq	-24(%rbp), %rcx
	movq	%rax, (%rcx)
	testq	%rax, %rax
	je	.L7
	movq	-32(%rbp), %rax
	movq	(%rax), %rdi
	movl	$200, %edx
	movl	$longjmp, %esi
	call	png_set_longjmp_fn
	movq	%rax, %rdi
	call	_setjmp
	testl	%eax, %eax
	jne	.L8
	movq	-8(%rbp), %rbx
	leave
	.cfi_remember_state
	.cfi_def_cfa 7, 8
	ret
.L6:
	.cfi_restore_state
	movq	-24(%rbp), %rax
	movq	$0, (%rax)
	call	exit
.L7:
	movl	$0, %edx
	movl	$0, %esi
	movq	-32(%rbp), %rdi
	call	png_destroy_read_struct
	movl	$0, %edi
	call	exit
.L8:
	movl	$0, %edx
	movq	-24(%rbp), %rsi
	movq	-32(%rbp), %rdi
	call	png_destroy_read_struct
	movl	$0, %edi
	call	exit
	.cfi_endproc
.LFE22:
	.size	init_png, .-init_png
	.section	.rodata.str1.1
.LC1:
	.string	"rb"
	.text
	.globl	read_png
	.type	read_png, @function
read_png:
.LFB23:
	.cfi_startproc
	pushq	%rbp
	.cfi_def_cfa_offset 16
	.cfi_offset 6, -16
	movq	%rsp, %rbp
	.cfi_def_cfa_register 6
	pushq	%r15
	pushq	%r14
	pushq	%r13
	pushq	%r12
	pushq	%rbx
	subq	$72, %rsp
	.cfi_offset 15, -24
	.cfi_offset 14, -32
	.cfi_offset 13, -40
	.cfi_offset 12, -48
	.cfi_offset 3, -56
1:	call	mcount
	movq	%rsi, %r13
	movl	$.LC1, %esi
	call	fopen
	movq	%rax, %rbx
	movq	%rax, -112(%rbp)
	leaq	-64(%rbp), %rsi
	leaq	-56(%rbp), %rdi
	call	init_png
	movq	%rbx, %rsi
	movq	-56(%rbp), %rdi
	call	png_init_io
	movl	$0, %ecx
	movl	$144, %edx
	movq	-64(%rbp), %rsi
	movq	-56(%rbp), %rdi
	call	png_read_png
	subq	$8, %rsp
	pushq	$0
	pushq	$0
	leaq	-84(%rbp), %rax
	pushq	%rax
	leaq	-80(%rbp), %r9
	leaq	-76(%rbp), %r8
	leaq	-72(%rbp), %rcx
	leaq	-68(%rbp), %rdx
	movq	-64(%rbp), %rsi
	movq	-56(%rbp), %rdi
	call	png_get_IHDR
	addq	$32, %rsp
	movq	-64(%rbp), %rsi
	movq	-56(%rbp), %rdi
	call	png_get_rowbytes
	movq	%rax, %r15
	movl	%eax, -104(%rbp)
	movl	%eax, %r12d
	sall	$7, %r12d
	movslq	%r12d, %rdi
	call	malloc
	movq	%rax, 0(%r13)
	movq	-64(%rbp), %rsi
	movq	-56(%rbp), %rdi
	call	png_get_rows
	movq	%rax, %rbx
	movl	%r15d, %r14d
	negl	%r14d
	movslq	%r14d, %r14
	subl	%r15d, %r12d
	movslq	%r12d, %r12
	leaq	1024(%rax), %r15
	movslq	-104(%rbp), %rax
	movq	%rax, -104(%rbp)
.L10:
	movq	%r12, %rdi
	addq	0(%r13), %rdi
	movq	(%rbx), %rsi
	movq	-104(%rbp), %rdx
	call	memcpy
	addq	$8, %rbx
	addq	%r14, %r12
	cmpq	%r15, %rbx
	jne	.L10
	movl	$0, %edx
	leaq	-64(%rbp), %rsi
	leaq	-56(%rbp), %rdi
	call	png_destroy_read_struct
	movq	-112(%rbp), %rdi
	call	fclose
	leaq	-40(%rbp), %rsp
	popq	%rbx
	popq	%r12
	popq	%r13
	popq	%r14
	popq	%r15
	popq	%rbp
	.cfi_def_cfa 7, 8
	ret
	.cfi_endproc
.LFE23:
	.size	read_png, .-read_png
	.ident	"GCC: (GNU) 12.2.1 20220819 (Red Hat 12.2.1-2)"
	.section	.note.GNU-stack,"",@progbits
